; MP3 Player, Test DRAM, http://www.pjrc.com/tech/mp3
; Copyright (c) 2000, PJRC.COM, LLC

; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

; As a specific exception to the GPL, the executable object code built
; from this source code may be combined with hardware configuration data
; files.  A hardware configuration data file is a set of data that is
; transmitted to an intergrated circuit that is not a general purpose
; microprocessor or microcontroller, in order to establish its normal
; operation.  The process of combining the executable ojbect code built
; from the GPL licensed source code with the hardware configuration data
; shall be considered an aggregation of another work not based on the
; Program.  While the GPL does not restrict use of the program, any
; use restriction associated with the hardware configuration data (for
; example, that it only be used with particular hardware) shall apply
; to the combined file which includes a copy of the hardware configuration
; data.

; Contact: paul@pjrc.com


.equ    location, 0x6000        ;where this program will exist


.equ    cout, 0x0030            ;Send Acc to serial port
.equ    cin, 0x0032             ;Get Acc from serial port
.equ    phex, 0x0034            ;Print Hex value of Acc
.equ	phex1, 0x002E
.equ    phex16, 0x0036          ;Print Hex value of DPTR
.equ    pstr, 0x0038            ;Print string pointed to by DPTR,
.equ    upper, 0x0040           ;Convert Acc to uppercase
.equ    pint8u, 0x004D          ;print Acc at an integer, 0 to 255
.equ    pint8, 0x0050           ;print Acc at an integer, -128 to 127
.equ    pint16u, 0x0053         ;print DPTR as an integer, 0 to 65535
.equ    newline, 0x0048         ;print CR/LF (13 and 10)
.equ    cin_filter, 0x0062      ;get a character, but look for esc sequences


.equ	call_bank1, 0x0FE0
.equ	alt_xdownload, 0xA049
.equ    sta013_init, 0xA043





.org    location
.db     0xA5,0xE5,0xE0,0xA5     ;signiture bytes
.db     254,'T',0,0             ;id
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;user defined
.db     255,255,255,255         ;length and checksum (255=unused)
.db     "Test DRAM",0
.org    location+64             ;executable code begins here



;memory map:
;
;4 megs, pages 0 to 1023
;8 megs, pages 0 to 2047
;16 mges, pages 0 to 1023, 2048 to 3071, 4096 to 5119, and 6144 to 7167
;32 megs, pages 0 to 8191


dram_test:
	acall	cfg_fpga

	mov	dptr, #0
	acall	set_page
	acall	wr_dram
	mov	dptr, #0
	acall	set_page
	acall	ck_dram
	jnc	dtest2
	mov	dptr, #msg_bad_simm
	lcall	pstr
	ret

dtest2:
	;in a smaller 4 or 8 meg simm, writing to block 2048 will
	;overwrite whatever's in block 0, but 16 and 32 meg simms
	;have a block 2048, so writing to block 0, then 2048, and
	;checking to see if block 0 still is correct will tell if
	;the simm is (4 or 8) vs (16 or 32).
	mov	dptr, #2048
	acall	set_page
	acall	wr_dram
	mov	dptr, #0
	acall	set_page
	acall	ck_dram			;check if it's 4/8 or 16/32
	cpl	c
	clr	a
	mov	acc.1, c
	mov	r4, a

	;double sided simms (8 and 32 megs) implement block 1024
	;whereas single sided simms can't implement block 1024, so
	;writing and checking 1024 will tell if it's a single
	;(4 or 16) or double (8 or 32).
	mov	dptr, #1024
	acall	set_page
	acall	wr_dram
	mov	dptr, #1024
	acall	set_page
	acall	ck_dram			;check if it's 4/16 or 8/32
	cpl	c
	mov	a, r4
	mov	acc.0, c
	mov	r4, a

	mov	dptr, #msg_found
	lcall	pstr
	mov	a, r4
	acall	simm_size
	lcall	pint8
	mov	dptr, #msg_size
	lcall	pstr





	ret



	mov	dptr, #0xFF00
	mov	r0, #32
	mov	a, #0xFF
test_loop1:
	movx	@dptr, a
	inc	dptr
	djnz	r0, test_loop1

	mov	dptr, #0xFF00
	mov	a, #0
	movx	@dptr, a

test_loop2:
	mov	dptr, #0xFF10
	movx	a, @dptr
	lcall	phex
	lcall	wait
	sjmp	test_loop2
	ret




simm_size:
	inc	a
	movc	a, @a+pc
	ret
	.db	4, 8, 16, 32
	

set_page:
	mov	a, dpl
	xrl	a, dph
	xrl	a, #10110010b
	mov	r5, a
	mov	a, dpl
	mov	b, dph
	mov	dptr, #dram_page_cfg
	movx	@dptr, a
	inc	dptr
	mov	a, b
	movx	@dptr, a
	ret



	;write 7 bytes at 0000 to 00FF, using r5 as a seed
wr_dram:
	mov	dptr, #dram_page_cfg
	movx	a, @dptr
	xrl	a, #01110101b
	mov	dptr, #0
	movx	@dptr, a
	mov	dptr, #dram_page_cfg+1
	movx	a, @dptr
	xrl	a, #11011011b
	mov	dptr, #1
	movx	@dptr, a
	mov	dptr, #2
wr2:
	acall	rand8
	movx	@dptr, a
	inc	dptr
	mov	a, dpl
	cjne	a, #9, wr2
	ret



	;checks 7 bytes from 0000 to 00FF, r5 is seed
	;return C=0 if good, C=1 if any error
ck_dram:
	mov	dptr, #dram_page_cfg
	movx	a, @dptr
	xrl	a, #01110101b
	mov	b, a
	mov	dptr, #0
	movx	a, @dptr
	cjne	a, b, ck_err
	mov	dptr, #dram_page_cfg+1
	movx	a, @dptr
	xrl	a, #11011011b
	mov	b, a
	mov	dptr, #1
	movx	a, @dptr
	cjne	a, b, ck_err
	mov	dptr, #2
ck2:
	acall	rand8
	mov	b, a
	movx	a, @dptr
	cjne	a, b, ck_err
	inc	dptr
	mov	a, dpl
	cjne	a, #9, wr2
	clr	c
	ret
ck_err:
	setb	c
	ret





; generate an 8 bit random number, r5 holds the "seed"

rand8:  mov     a, r5
        jnz     rand8b
        cpl     a
        mov     r5, a
rand8b: anl     a, #10111000b
        mov     c, p
        mov     a, r5
        rlc     a
        mov     r5, a
        ret





cfg_fpga:
	mov	dptr, #mesg_xilinx_cfg
	lcall	pstr
	mov	dptr, #alt_xdownload
	lcall	call_bank1
	jc	error
	mov	dptr, #mesg_ok
	lcall	pstr
	ret
cfg_sta013:
	;init the sta013 chip
        mov     dptr, #mesg_sta013_cfg
        lcall   pstr
        mov     dptr, #sta013_init
        lcall   call_bank1
        jc      error
        mov     dptr, #mesg_ok
        lcall   pstr
	ajmp	pg_setup
	ret
error:
	mov	dptr, #mesg_error
	lcall	pstr
	ljmp	0



















.org	location+0x200
.db     0xA5,0xE5,0xE0,0xA5     ;signiture bytes
.db     254,'W',0,0              ;id, 35=program
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;user defined
.db     255,255,255,255         ;length and checksum (255=unused)
.db     "MP3 DMA Test",0
.org    location+0x200+64             ;executable code begins here


	

	mov	dptr, #msg_dma_test	;print a welcome message
	lcall	pstr

	;init the xilinx chip
	lcall	cfg_fpga

	lcall	cfg_sta013

	;set up page mapping so we have 60k of RAM to use
pg_setup:
	mov	dptr, #dram_page_cfg
pgs2:	mov	a, dpl
	acall	pg_table
	movx	@dptr, a
	inc	dptr
	mov	a, dpl
	cjne	a, #30, pgs2

	;initialize the drive.  If there is no drive, this may hang
	acall	ide_init


	mov	dptr, #msg_reading	;print a welcome message
	lcall	pstr

	;read in 60k of MP3 data, beginning at this sector
	mov	lba+0, #0xD9
	mov	lba+1, #0x84
	mov	lba+2, #0
	mov	lba+3, #0

	mov	sec_count, #0
	mov	dptr, #0
rd_loop:
	push	dph
	push	dpl
	acall	read_sec_dptr
	acall	inc_lba
	pop	dpl
	pop	acc
	add	a, #2
	mov	dph, a
	inc	sec_count
	mov	a, sec_count
	cjne	a, #120, rd_loop

	acall	ide_sleep

	mov	dptr, #msg_playing
	lcall	pstr

sta013_dma:
	mov	dptr, #dma_mp3_src
	clr	a
	movx	@dptr, a		;write LSB of src addr
	inc	dptr
	clr	a
	movx	@dptr, a		;write MSB of src addr

	mov	dptr, #dma_mp3_count
	mov	a, #0
	movx	@dptr, a		;write LSB of length
	inc	dptr
	mov	a, #120
	movx	@dptr, a		;write MSB of length

	mov	dptr, #irq_dma_mp3_ack
	movx	@dptr, a		;clear any previous interrupt
	mov	dptr, #dma_mp3_go
	movx	@dptr, a		;begin the transfer
	;now we just wait for it to finish
	mov	dptr, #irq_ident
mp3_dma_wait:
	acall	wait
	movx	a, @dptr
	jnb	acc.1, mp3_dma_wait

	jnb	ri, sta013_dma		;keep looping until a keypress

	mov	dptr, #msg_done
	lcall	pstr

	ret


        ;put the drive into sleep mode

ide_sleep:
        ; acall ide_busy
        mov     dptr, #ide_command
        mov     a, #ide_cmd_sleep
        movx    @dptr, a
        ;acall  ide_busy
        mov     dptr, #ide_status
        movx    a, @dptr
        ret




pg_table:
	inc	a
	movc	a, @a+pc
	ret
	.db	1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7, 0
	.db	8, 0, 9, 0, 10, 0, 11, 0, 12, 0, 13, 0, 14, 0, 15, 0



inc_lba:
	mov	a, lba+0
	add	a, #1
	mov	lba+0, a
	mov	a, lba+1
	addc	a, #0
	mov	lba+1, a
	mov	a, lba+2
	addc	a, #0
	mov	lba+2, a
	mov	a, lba+3
	addc	a, #0
	mov	lba+3, a
	ret














; Simple communication with an IDE disk drive


.equ	buffer, 0x0000		;a 512 byte buffer

;registers implemented in the FPGA
.equ	dram_page_cfg,	0xFF00
.equ	ide_data,	0xFF60
.equ	ide_err,	0xFF62
.equ	ide_sec_cnt,	0xFF64
.equ	ide_sector,	0xFF66
.equ	ide_cyl_lsb,	0xFF68
.equ	ide_cyl_msb,	0xFF6A
.equ	ide_head,	0xFF6C
.equ	ide_command,	0xFF6E
.equ	ide_status,	0xFF6E
.equ	ide_control,	0xFF7C
.equ	ide_astatus,	0xFF7E
.equ	ide_rst_bit,	0xFF40
.equ	ide_data_buf_msb, 0xFF43
.equ	dma_ide_dest,	0xFF22
.equ	dma_ide_count,	0xFF24
.equ	irq_dma_ide_ack,0xFF5C
.equ	dma_ide_go,	0xFF58
.equ	irq_ident,	0xFF50
.equ	dma_mp3_src,	0xFF28
.equ	dma_mp3_count,	0xFF2A
.equ	dma_mp3_go,	0xFF59
.equ	irq_dma_mp3_ack,0xFF5D

;IDE Command Constants.  These should never change.
.equ	ide_cmd_recal, 0x10
.equ	ide_cmd_read, 0x20
.equ	ide_cmd_write, 0x30
.equ	ide_cmd_init, 0x91
.equ	ide_cmd_id, 0xEC
.equ	ide_cmd_spindown, 0xE6
.equ	ide_cmd_spinup, 0xE1
.equ    ide_cmd_sleep, 0xE6



;------------------------------------------------------------------
;internal ram usage

.equ	lba, 0x70		;4 bytes, 28 bit Logical Block Address
.equ	sec_count, 0x74


;------------------------------------------------------------------
; Main Program, a simple menu driven interface.


.org	location+0x400
.db     0xA5,0xE5,0xE0,0xA5     ;signiture bytes
.db     35,255,0,0              ;id, 35=program
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;user defined
.db     255,255,255,255         ;length and checksum (255=unused)
.db     "IDE Disk Drive Test",0
.org    location+0x400+64             ;executable code begins here


	lcall	cfg_fpga

	mov	dptr, #msg_1	;print a welcome message
	lcall	pstr

	;initialize the drive.  If there is no drive, this may hang
	acall	ide_init

	;get the drive id info.  If there is no drive, this may hang
	acall	drive_id

	; print the drive's model number
	mov	dptr, #msg_mdl
	lcall	pstr
	mov	dptr, #buffer + 60
	mov	r0, #40
	acall	print_name
	lcall	newline

	; print the drive's serial number
	mov	dptr, #msg_sn
	lcall	pstr
	mov	dptr, #buffer + 20
	mov	r0, #20
	acall	print_name
	lcall	newline

	; print the drive's cylinder, head, and sector specs
	mov	dptr, #msg_cy
	lcall	pstr
	mov	dptr, #buffer + 2
	acall	print_parm
	mov	dptr, #msg_hd
	lcall	pstr
	mov	dptr, #buffer + 6
	acall	print_parm
	mov	dptr, #msg_sc
	lcall	pstr
	mov	dptr, #buffer + 12
	acall	print_parm
	lcall	newline
	lcall	newline

	; default position will be first block (master boot record)
	clr	a
	mov	lba+0, a
	mov	lba+1, a
	mov	lba+2, a
	mov	lba+3, a


main_loop:				;print a 1-line prompt
	mov	dptr, #msg_l
	lcall	pstr
	mov	a, lba+3
	lcall	phex
	mov	a, lba+2
	lcall	phex
	mov	a, lba+1
	lcall	phex
	mov	a, lba+0
	lcall	phex
	mov	dptr, #msg_pmt
	lcall	pstr
	lcall	cin
	lcall	upper

main1:	cjne	a, #'R', main2		;read a sector
	
	mov	r2, #200
readmany:
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector

	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector

	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	;acall	read_sector
	acall	read_sector

	;djnz	r2, readmany

	jz	main1b
	push	acc
	mov	dptr, #msg_err
	lcall	pstr
	pop	acc
	lcall	phex
	lcall	newline
	ajmp	main_loop
main1b:	mov	dptr, #msg_rd
	lcall	pstr
	ajmp	main_loop

main2:	cjne	a, #'W', main3		;write a sector
	mov	dptr, #msg_sure
	lcall	pstr
	lcall	cin
	lcall	upper
	cjne	a, #'Y', main2c
	acall	write_sector
	jz	main2b
	push	acc
	mov	dptr, #msg_err
	lcall	pstr
	pop	acc
	lcall	phex
	lcall	newline
	ajmp	main_loop
main2b:	mov	dptr, #msg_wr
	lcall	pstr
main2c: ajmp	main_loop

main3:	cjne	a, #'L', main4		;set the logical block address
	mov	dptr, #msg_cyh
	lcall	pstr
	lcall	ghex32_lba
	jc	main3b
	mov	lba+0, r3
	mov	lba+1, r4
	mov	lba+2, r5
	mov	lba+3, r6
main3b:	lcall	newline
	ajmp	main_loop

main4:	cjne	a, #'U', main5		;cause the drive to spin up
	acall	spinup
	ajmp	main_loop

main5:	cjne	a, #'D', main6		;cause the drive to spin down
	acall	spindown
	ajmp	main_loop

main6:	cjne	a, #'Q', main7		;quit
	ljmp	0

main7:	cjne	a, #'H', main8
	acall	hexdump
	ajmp	main_loop

main8:	ajmp	main_loop






;------------------------------------------------------------------
; Routines that talk with the IDE drive, these should be called by
; the main program.







	;read a sector, specified by the 4 bytes in "lba",
	;Return, acc is zero on success, non-zero for an error
read_sector:
	acall	ide_busy		;make sure drive is ready
	acall	wr_lba			;tell it which sector we want
	mov	dptr, #ide_command
	mov	a, #ide_cmd_read
	movx	@dptr, a		;ask the drive to read it
	acall	ide_drq			;wait until it's got the data
	jb	acc.0, get_err
	mov	dptr, #buffer
	acall	read_data		;grab the data
	clr	a
	ret


read_sec_dptr:
	push	dph
	push	dpl
	acall	ide_busy		;make sure drive is ready
	acall	wr_lba			;tell it which sector we want
	mov	dptr, #ide_command
	mov	a, #ide_cmd_read
	movx	@dptr, a		;ask the drive to read it
	acall	ide_drq			;wait until it's got the data
	jb	acc.0, get_err
	pop	dpl
	pop	dph
	acall	read_data		;grab the data
	clr	a
	ret





	;when an error occurs, we get acc.0 set from a call to ide_drq
	;or ide_busy (which read the drive's status register).  If
	;that error bit is set, we should jump here to read the drive's
	;explaination of the error, to be returned to the user.  If for
	;some reason the error code is zero (shouldn't happen), we'll
	;return 255, so that the main program can always depend on a
	;return of zero to indicate success.
get_err:mov	dptr, #ide_err
	movx	a, @dptr
	jz	gerr2
	ret
gerr2:	mov	a, #255
	ret


	;write a sector, specified by the 4 bytes in "lba",
	;whatever is in the buffer gets written to the drive!
	;Return, acc is zero on success, non-zero for an error
write_sector:
	acall	ide_busy		;make sure drive is ready
	acall	wr_lba			;tell it which sector we want
	mov	dptr, #ide_command
	mov	a, #ide_cmd_write
	movx	@dptr, a		;tell drive to write a sector
	acall	ide_drq			;wait unit it wants the data
	jb	acc.0, get_err
	mov	dptr, #buffer
	acall	write_data		;give the data to the drive
	acall	ide_busy		;wait until the write is complete
	jb	acc.0, get_err
	clr	a
	ret



	;do the identify drive command, and return with the buffer
	;filled with info about the drive
drive_id:
	acall	ide_busy
	mov	dptr, #ide_command
	mov	a, #ide_cmd_id
	movx	@dptr, a
	acall	ide_drq
	mov	dptr, #buffer
	acall	read_data
	ret


	;tell the drive to spin up
spinup:
	mov	dptr, #ide_command
	mov	a, #ide_cmd_spinup
	movx	@dptr, a
	ajmp	ide_busy

	;tell the drive to spin down
spindown:
	acall	ide_busy
	mov	dptr, #ide_command
	mov	a, #ide_cmd_spindown
	movx	@dptr, a
	ajmp	ide_busy


	;initialize the ide drive
ide_init:
	acall	ide_hard_reset
ide_init_wait:
	mov	dptr, #ide_head
	mov	a, #10100000b
	movx	@dptr, a		;select the master device

	acall	wait
	mov	a, #'*'
	lcall	cout

	mov	dptr, #ide_status
	movx	a, @dptr

	;should probably check for a timeout here
	jnb	acc.6, ide_init_wait	;wait for RDY bit to be set
	jb	acc.7, ide_init_wait	;wait for BSY bit to be clear

	lcall	newline

	mov	dptr, #ide_command
	mov	a, #ide_cmd_recal	;do recal command (is this necessary?)
	movx	@dptr, a
	ajmp	ide_busy



;------------------------------------------------------------------
; Not quite as low, low level I/O.  These routines talk to the drive,
; using the low level I/O.  Normally a main program should not call
; directly to these.

	;Read a block of 512 bytes (one sector) from the drive
	;and store it in memory @ DPTR
read_data:
	;ajmp	read_data_pio


	;read 512 bytes of data using fast DMA
read_data_dma:
	mov	a, dpl
	mov	b, dph
	mov	dptr, #dma_ide_dest
	movx	@dptr, a		;write LSB of dest addr
	inc	dptr
	mov	a, b
	movx	@dptr, a		;write LSB of dest addr
	mov	dptr, #dma_ide_count
	clr	a
	movx	@dptr, a
	inc	dptr
	mov	a, #1
	movx	@dptr, a		;request 256 16 bit reads
	mov	dptr, #irq_dma_ide_ack
	movx	@dptr, a		;clear any previous interrupt
	mov	dptr, #dma_ide_go
	movx	@dptr, a		;begin the transfer
	;now we just wait for it to finish
	mov	dptr, #irq_ident
dma_wait:
	movx	a, @dptr		;2  1 psen = 2 bytes transfered
	jnb	acc.0, dma_wait		;2  3 psen = 6 bytes transfered
	ret

	;speed = 8 bytes per 4 cycles -> 1229 kbyte/sec
	;  remember, this is raw transfer speed, and doesn't
	;  include the time to set up the transfer.
	
	;Ideally, we'd be executing real code instead of this
	;busy loop.  With some luck, real code would have more
	;psen's per second than movx (only mul and div have less).
	;If we call into PM2, the psens (and dma) will stall!

	;Maybe someday the DMA controller will be able to detect
	;unused bus time and use it... that'd double the speed for
	;this test case.  Will need to investigate actual speed once
	;the drivers are written and somewhat mature.  A really
	;ambitious approach would be to watch the psen fetch and
	;do a little table lookup of the opcode, and let the state
	;machine run full speed for the entire instruction and
	;into the fetch of the next opcode, so we could use all
	;the available time.  Maybe someday when I have lots of
	;free time (highly unlikely).



	;read 512 bytes of data using slow I/O
read_data_pio:
	mov	r5, #0
rdblk2: push	dph			;2
	push	dpl			;2
	mov	dptr, #ide_data		;2
	movx	a, @dptr		;2  read lsb
	mov	r2, a			;1
	mov	dptr, #ide_data_buf_msb	;2
	movx	a, @dptr		;2  read msb
	mov	r3, a			;1
	pop	dpl			;2
	pop	dph			;2
	mov	a, r2			;1
	movx	@dptr, a		;2  write lsb
	inc	dptr			;2
	mov	a, r3			;1
	movx	@dptr, a		;2  write msb
	inc	dptr			;2
	djnz	r5, rdblk2		;2
	ret

	;speed = 2 bytes per 30 cycles -> 41 kbyte/sec





	;Write a block of 512 bytes (at DPTR) to the drive
write_data:
	mov	r5, #0
wrblk2: movx	a, @dptr		;read lsb
	mov	r2, a
	inc	dptr
	movx	a, @dptr		;read msb
	mov	r3, a
	inc	dptr
	push	dph
	push	dpl
	mov	dptr, #ide_data_buf_msb
	mov	a, r3
	movx	@dptr, a		;write msb
	mov	dptr, #ide_data
	mov	a, r2
	movx	@dptr, a		;write lsb
	pop	dpl
	pop	dph
	djnz	r5, wrblk2
	ret



	;write the logical block address to the drive's registers
wr_lba:
	mov	a, lba+3
	anl	a, #0x0F
	orl	a, #0xE0
	mov	dptr, #ide_head
	movx	@dptr, a
	mov	a, lba+2
	mov	dptr, #ide_cyl_msb
	movx	@dptr, a
	mov	a, lba+1
	mov	dptr, #ide_cyl_lsb
	movx	@dptr, a
	mov	a, lba+0
	mov	dptr, #ide_sector
	movx	@dptr, a
	mov	a, #1
	mov	dptr, #ide_sec_cnt
	movx	@dptr, a
	ret




	;Wait for the ide drive to not be busy.
	;Returns the drive's status in Acc
ide_busy:
	acall	wait
	;mov	a, #'.'
	;lcall	cout
	mov	dptr, #ide_status	;wait for RDY bit to be set
	movx	a, @dptr
	;should probably check for a timeout here
	jb	acc.7, ide_busy
	ret


	;Wait for the drive to be ready to transfer data.
	;Returns the drive's status in Acc
ide_drq:
	acall	wait
	;mov	a, #'_'
	;lcall	cout
	mov	dptr, #ide_status	;wait for DRQ bit to be set
	movx	a, @dptr
	;should probably check for a timeout here
	jb	acc.7, ide_drq		;wait for BSY to be clear
	jnb	acc.3, ide_drq		;wait for DRQ to be set
	ret



	;do a hard reset on the drive, by pulsing its reset pin.
	;this should usually be followed with a call to "ide_init".
ide_hard_reset:
	mov	dptr, #ide_rst_bit
	clr	a
	movx	@dptr, a		;assert the reset pin
	acall	delay_10ms		;IDE requires reset > 25 ms
	acall	delay_10ms
	acall	delay_10ms
	mov	a, #1
	movx	@dptr, a		;de-assert the reset pin
	acall	delay_10ms		;brief delay while drive inits
	ret



	;delay for 10 ms
	;10ms at 7.3728 MHz is 6144 machine cycles
	;6144 = 256 * 24
delay_10ms:
	mov	r0, #0
d1ms:	mov	r1, #10		;1 cycle
	djnz	r1, *		;20 cycles
	nop			;1 cycle
	djnz	r0, d1ms	;2 cycles
five_cy:nop
	ret



;------------------------------------------------------------------
; Some additional serial I/O routines not available in PAULMON


	;print a 16 bit number, located at DPTR
print_parm:
	movx	a, @dptr
	push	acc
	inc	dptr
	movx	a, @dptr
	mov	dph, a
	pop	dpl
	ljmp	pint16u



	;print a string, no more than R0 chars long
print_name:
	movx	a, @dptr
	jz	pn_end
	lcall	cout
	inc	dptr
	djnz	r0, print_name
pn_end:	ret



	;get a 32 bit input, in hex
ghex32_lba:
	mov	r2, #8
	mov	r3, #0
	mov	r4, #0
	mov	r5, #0
	mov	r6, #0
gh32c:	lcall	cin_filter
	lcall	upper
	cjne	a, #27, gh32d
	setb	c
	ret
gh32d:	cjne	a, #8, gh32f
	sjmp	gh32k
gh32f:	cjne	a, #127, gh32g
gh32k:	cjne	r2, #8, gh32e
	sjmp	gh32c
gh32e:	lcall	cout
	mov	r0, #4
gh32yy:	clr	c
	mov	a, r6
	rrc	a
	mov	r6, a
	mov	a, r5
	rrc	a
	mov	r5, a
	mov	a, r4
	rrc	a
	mov	r4, a
	mov	a, r3
	rrc	a
	mov	r3, a
	djnz	r0, gh32yy
	inc	r2
	sjmp	gh32c
gh32g:	cjne	a, #13, gh32i
	clr	c
	ret
gh32i: 	mov	r7, a
	acall	asc2hex
	jc	gh32c
	xch	a, r7
	lcall	cout
	mov	a, r7
	swap	a
	mov	r7, a
	mov	r0, #4
gh32j:	mov	a, r7
	rlc	a
	mov	r7, a
	mov	a, r3
	rlc	a
	mov	r3, a
	mov	a, r4
	rlc	a
	mov	r4, a
	mov	a, r5
	rlc	a
	mov	r5, a
	mov	a, r6
	rlc	a
	mov	r6, a
	djnz	r0, gh32j
	djnz	r2, gh32c
	clr	c
	ret



        ;carry set if invalid input
asc2hex:
        clr     c
        add     a, #208
        jnc     hex_not
        add     a, #246
        jc      hex_maybe
        add     a, #10
        clr     c
        ret
hex_maybe:
        add     a, #249
        jnc     hex_not
        add     a, #250
        jc      hex_not
        add     a, #16
        clr     c
        ret
hex_not:setb    c
        ret


	;print a hexdump of the data in the 512 byte buffer
hexdump:
	lcall	newline
	mov	r2, #32		;print 32 lines
	mov	dptr, #buffer
hd1:	mov	a, dph
	mov	r5, a
	clr	c
	subb	a, #buffer >> 8
	lcall	phex		;print address, starting at zero
	mov	a, dpl
	mov	r4, a
	lcall	phex
	mov	a, #':'
	lcall	cout
	acall	space
	mov	r3, #16		;print 16 hex bytes per line
hd2:	movx	a, @dptr
	inc	dptr
	lcall	phex		;print each byte in hex
	acall	space
	djnz	r3, hd2
	acall	space
	acall	space
	acall	space
	mov	dpl, r4
	mov	dph, r5
	mov	r3, #16		;print 16 ascii bytes per line
hd3:	movx	a, @dptr
	inc	dptr
	anl	a, #01111111b	;only 7 bits for ascii
	cjne	a, #127, hd3b
	clr	a		;avoid 127/255 (delete/rubout) char
hd3b:	add	a, #224
	jc	hd3c
	clr	a		;avoid control characters
hd3c:	add	a, #32
	lcall	cout
	djnz	r3, hd3
	lcall	newline
	djnz	r2, hd1
	lcall	newline
	ret

space:	mov	a, #' '
	ljmp	cout



wait:
	jb	ri, quit
wait_ret:
	ret

quit:
	lcall	cin
	cjne	a, #27, wait_ret
	ljmp	0






.org    location+0x800
.db     0xA5,0xE5,0xE0,0xA5     ;signiture bytes
.db     254,'Y',0,0             ;id
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;user defined
.db     255,255,255,255         ;length and checksum (255=unused)
.db     "Init Memory Mgr",0
.org    location+0x800+64       ;executable code begins here



;memory block descriptor, 16 bytes
;
;byte 0/1: number of next block in a linked list

;byte 2/15: unused, someday may hold info about each block




	;initialize the memory manager, figure out what
	;SIMM is installed, and initialize the memory
	;block descriptor table.  The first 32 blocks
	;are always used for the table itself, regardless
	;of what SIMM is installed.  All the rest are
	;either free blocks, or not implemented by the SIMM.
	;The xilinx chip needs to be configured with the
	;DRAM controller before calling here.
	;return: C=1 if an error (no SIMM), C=0 for success

init_memory_mgr:
	mov	dptr, #0
	acall	map_page_0
	acall	write_test_bytes
	acall	check_test_bytes
	jnc	initmm2
	mov	dptr, #msg_bad_simm
	lcall	pstr
	ret			;error, no simm is installed
initmm2:
	;in a smaller 4 or 8 meg simm, writing to block 2048 will
	;overwrite whatever's in block 0, but 16 and 32 meg simms
	;have a block 2048, so writing to block 0, then 2048, and
	;checking to see if block 0 still is correct will tell if
	;the simm is (4 or 8) vs (16 or 32).
	mov	dptr, #2048
	acall	map_page_0
	acall	write_test_bytes
	mov	dptr, #0
	acall	map_page_0
	acall	check_test_bytes
	mov	acc.1, c
	push	acc

	;double sided simms (8 and 32 megs) implement block 1024
	;whereas single sided simms can't implement block 1024, so
	;writing and checking 1024 will tell if it's a single
	;(4 or 16) or double (8 or 32).
	mov	dptr, #1024
	acall	map_page_0
	acall	write_test_bytes
	acall	check_test_bytes
	pop	acc
	mov	acc.0, c
	cpl	a
	anl	a, #3
	mov	r4, a		;r4 has simm size, 0 to 3
	add	a, #2
	movc	a, @a+pc	;now Acc has simm size, in Mbytes
	sjmp	initmm3
	.db	4, 8, 16, 32
initmm3:
	;print a message here about which simm we found
	push	acc
	mov	dptr, #msg_found
	lcall	pstr
	pop	acc
	lcall	pint8
	mov	dptr, #msg_size
	lcall	pstr


	mov	r2, #0		;r2 will count which 1MB section (0-31)
initmm4:
	mov	a, r2
	acall	is_implemented
	jz	initmm9		;don't bother if not implemented
	mov	dpl, r2
	mov	dph, #0
	acall	map_page_0

	mov	a, #'p'
	acall	cout_eq
	mov	a, r2
	lcall	phex

initmm5:
	;whatever page is mapped at 1000 to 1FFF is the previous
	;page where we didn't write the last entry, but now we
	;know what it will be, so write it now.
	mov	a, r2
	jz	initmm6		;don't do this the first time
	mov	dptr, #0x1FF0
	clr	a
	movx	@dptr, a
	inc	dptr
	mov	a, r2
	movx	@dptr, a
initmm6:
	;first, let's just rapidly fill up the linked list
	;knowing that the last one may be wrong, since we
	;don't know where it will point yet.  We do know
	;that each block will always point to the next in
	;a 1 meg page, at least initially when all the
	;memory is free and we're just initializing.
	mov	r3, #0		;r3 counts page within that 1MB (0-255)
	mov	dptr, #0
initmm7:
	inc	r3
	mov	a, r3
	movx	@dptr, a
	inc	dptr
	mov	a, r2
	movx	@dptr, a
	mov	a, dpl
	add	a, #15
	mov	dpl, a
	mov	a, dph
	addc	a, #0
	mov	dph, a
	anl	a, #0xF0
	jz	initmm7

	;now map this page at 1000 to 1FFF, so later we can write
	;the last entry to point to the next 1MB part
	mov	dpl, r2
	mov	dph, #0
	acall	map_page_1
initmm9:
	inc	r2
	cjne	r2, #32, initmm4

	;the very last entry needs a NULL to terminate the list
	mov	dptr, #0x1FF0
	clr	a
	movx	@dptr, a
	inc	dptr
	movx	@dptr, a

	lcall	newline

	;now we need to make the first 32 pages not free,
	;since they're used for tracking what memory is
	;used and what's free
	mov	dptr, #0
	acall	map_page_0
	mov	dptr, #0x01F0
	clr	a
	movx	@dptr, a
	inc	dptr
	movx	@dptr, a

	;I hope that worked!
	ret



	;Allocate 1 or more 4k blocks of memory (specified by Acc).
	;The number of the first block is returned (in R2/R3) and
	;carry is cleared if the blocks were allocated.  Carry is
	;set if there are not enough free blocks.
malloc_blocks:
























	;This function returns zero if a particular simm
	;doesn't implement a particlar 1 MB memory range,
	;or non-zero if this simm implements that area.
	;inputs:
	;	acc = 1 MB memory area (0-32)
	;	r4 = simm type (0=4M, 1=8M, 2=16M, 3=32M)
is_implemented:
	rr	a
	rr	a
	anl	a, #7
	mov	r0, a
	mov	a, r4
	anl	a, #3
	add	a, #2
	movc	a, @a+pc
	sjmp	is_imp2
	.db	00000001b	;4 meg = blocks 0 to 1023
	.db	00000011b	;8 meg = blocks 0 to 2047
	.db	01010101b	;16 meg = blocks 0 to 1023
				;	blocks 2048 to 3071
				;	blocks 4096 to 5119
				;	blocks 6144 to 7167
	.db	11111111b	;32 meg = blocks 0 to 8191
is_imp2:
	cjne	r0, #0, is_imp3
	anl	a, #1
	ret
is_imp3:rr	a
	dec	r0
	sjmp	is_imp2




	;map a particular DRAM page into 0000 to 0FFF
map_page_0:
	mov	a, dpl
	mov	b, dph
	mov	dptr, #dram_page_cfg
	sjmp	map_page
	;map a particular DRAM page into 1000 to 1FFF
map_page_1:
	mov	a, dpl
	mov	b, dph
	mov	dptr, #dram_page_cfg+2
map_page:
	movx	@dptr, a
	inc	dptr
	mov	a, b
	movx	@dptr, a
	ret




map_block:
	anl	a, #15
	rl	a
	add	a, #dram_page_cfg & 255
	mov	dpl, a
	clr	a
	addc	a, #dram_page_cfg >> 8
	mov	dph, a
	mov	a, r2
	movx	@dptr, a
	inc	dptr
	mov	a, r3
	movx	@dptr, a
	ret









	;write a simple test to a DRAM page, just write
	;the page number a couple times, with different
	;XOR'd with different bit patterns.  This way,
	;we are unlikely to read garbage as good, and
	;it will always detect a page that is corrupted
	;by writing to a different page (small simms
	;which appear repeated 4 times)
write_test_bytes:
	mov	dptr, #dram_page_cfg
	movx	a, @dptr	;read page # lsb
	mov	b, a
	inc	dptr
	movx	a, @dptr	;read page # msb
	mov	dptr, #0
	xrl	a, #0x5A
	movx	@dptr, a
	inc	dptr
	cpl	a
	movx	@dptr, a
	inc	dptr
	mov	a, b
	xrl	a, #0x9C
	movx	@dptr, a
	inc	dptr
	cpl	a
	movx	@dptr, a
	ret

	;read a page previously written with "write_test_bytes"
	;and return C=0 if good, C=1 if wrong bytes read back
check_test_bytes:
	mov	dptr, #dram_page_cfg
	movx	a, @dptr	;read page # lsb
	mov	r0, a
	inc	dptr
	movx	a, @dptr	;read page # msb
	mov	b, a
	mov	dptr, #0
	movx	a, @dptr
	xrl	a, #0x5A
	cjne	a, b, cktb_err
	inc	dptr
	movx	a, @dptr
	xrl	a, #0xA5
	cjne	a, b, cktb_err
	inc	dptr
	mov	b, r0
	movx	a, @dptr
	xrl	a, #0x9C
	cjne	a, b, cktb_err
	inc	dptr
	movx	a, @dptr
	xrl	a, #0x63
	cjne	a, b, cktb_err
	clr	c
	ret
cktb_err:
	setb	c
	ret

















cout_eq:
	push	acc
	lcall	space
	pop	acc
	lcall	cout
	mov	a, #'='
	ljmp	cout















msg_1:	.db	"IDE Disk Drive Test Program",13,10,13,10,0
msg_mdl:.db	"Model: ",0
msg_sn: .db	"S/N:   ",0
msg_cy:	.db	"Cylinders: ", 0
msg_hd:	.db	", Heads: ", 0
msg_sc:	.db	", Sectors: ", 0
msg_cyh:.db	"Enter LBA (in hex): ", 0
msg_l:	.db	"LBA=0x",0
msg_pmt:.db	", (R)ead (W)rite (L)BA (U)p (D)own (H)exdump (Q)uit",13,10,0
msg_sure:.db	"Warning: this will change data on the drive, are you sure?",13,10,0

msg_rd:	.db	"Sector Read OK",13,10,0
msg_wr:	.db	"Sector Write OK",13,10,0
msg_err:.db	"Error, code = ",0

mesg_test:
	.db	"DRAM Test",13,10,0
mesg_xilinx_cfg:
	.db	"Configuring Xilinx XCS10XL FPGA Chip: ",0
mesg_ok:
	.db	"Ok",13,10,0
mesg_error:
	.db	"Error!",13,10,0


msg_bad_simm:
	.db	"Bad or Missing SIMM",13,10,0
msg_found:
	.db	"Found ",0
msg_size:
	.db	" meg SIMM",13,10,0
mesg_fill:
	.db	"Filling DRAM with test data",13,10,0
msg_ck:	.db	"Checking DRAM page ",0


msg_dma_test:
	.db	13,10,"DMA to MP3 decoder test: ",13,10,0
msg_reading:
	.db	13,10,"Reading in 60k of data from drive",13,10,0
mesg_sta013_cfg:
        .db     "Configuring STA013 MP3 Decoder Chip: ",0


msg_playing:
	.db	"Playing 60k of MP3 data using DMA...",13,10,0
msg_done:
	.db	"Done",13,10,0
